<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';

interface HeroImage {
  src: string;
  alt?: string;
}

interface HeroButton {
  text: string;
  href: string;
  variant?: string;
  icon?: string;
}

export default Vue.extend({
  props: {
    header: {
      type: String,
      required: true,
    },
    description: {
      type: String,
      required: true,
    },
    image: {
      type: Object as PropType<HeroImage>,
      required: true,
    },
    button: {
      type: Object as PropType<HeroButton>,
      required: false,
      default: null,
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <SlpContainer>
      <div class="hero-wrapper">
        <div class="hero-text slp-mr-md-64">
          <div class="animation-wrapper">
            <SlpTypography
              variant="heading2-bold"
              tag="h1"
              class="slp-mb-24 animated"
              >{{ header }}</SlpTypography
            >
          </div>
          <div class="animation-wrapper">
            <SlpTypography
              variant="body1"
              tag="h2"
              class="hero-description animated"
            >
              <div v-html="$md.render(description)" />
            </SlpTypography>
          </div>
          <div class="animation-wrapper">
            <SlpButton
              :href="button.href"
              :variant="button.variant"
              class="animated cta"
              data-ga-name="report"
              data-ga-location="hero"
              >{{ button.text }}
              <SlpIcon v-if="button.icon" v-bind="button.icon" class="slp-ml-8"
            /></SlpButton>
          </div>
        </div>
        <div class="hero-image">
          <img loading="lazy" :src="image.src" :alt="image.alt" />
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  padding: 96px 0;
  @media (max-width: $breakpoint-lg) {
    padding-top: 64px;
  }
  @media (min-width: $breakpoint-md) {
    margin-bottom: 170px;
  }
}
.hero-wrapper {
  display: flex;
  flex-direction: column;
  align-items: center;
  gap: 32px;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    align-items: center;
  }
  @media (min-width: $breakpoint-lg) {
    gap: 16px;
  }

  .hero-text {
    padding-top: 32px;
    flex: 1;
    @media (min-width: $breakpoint-md) {
      padding-top: 0;
    }
    .cta {
      @media (max-width: $breakpoint-lg) {
        width: 100%;
        justify-content: center;
      }
    }
    .animation-wrapper {
      overflow-y: clip;
      .animated {
        animation-name: intro-reveal;
        animation-fill-mode: forwards;
        animation-delay: 0.9s;
        animation-duration: 0.9s;
        transform: translate3d(0, 150%, 0);
        will-change: transform;
        @media (prefers-reduced-motion) {
          animation: none;
          transform: none !important;
        }
      }
    }
    .note {
      background: linear-gradient(
        91.08deg,
        #f9a026 -9.03%,
        #a686f2 27.88%,
        #592ac8 65.98%
      );
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
    }
  }
  .hero-image {
    opacity: 0;
    flex: 1;
    animation: opacity-intro 0.9s linear forwards 1.2s;
    img {
      max-width: 573px;
      margin-right: -150px;
      object-fit: cover;
      object-position: center;
      border-radius: 4px 4px 100px 4px;
      width: 573px;

      @media (max-width: $breakpoint-lg) {
        max-width: 100%;
        border-radius: 4px 4px 80px 4px;
        margin-right: 0;
      }
    }
  }
  .hero-description {
    &:deep(p) {
      margin-bottom: $spacing-24;
    }
  }
}

@keyframes intro-reveal {
  from {
    transform: translate3d(0, 150%, 0);
  }
  to {
    transform: translate3d(0, 0%, 0);
  }
}

@keyframes opacity-intro {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
</style>
